Index: /trunk/src/VBox/Main/ApplianceImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 17928)
+++ /trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 17929)
@@ -3199,4 +3199,7 @@
                                                       ComSafeArrayIn(IN_BSTR, argExtraConfigValues))
 {
+    NOREF(aEnabledSize);
+
+    CheckComArgSafeArrayNotNull(aEnabled);
     CheckComArgSafeArrayNotNull(argVboxValues);
     CheckComArgSafeArrayNotNull(argExtraConfigValues);
@@ -3492,5 +3495,5 @@
                                    strVbox);
             }
-            else 
+            else
                 throw rc;
         }
Index: /trunk/src/VBox/Main/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Main/Makefile.kmk	(revision 17928)
+++ /trunk/src/VBox/Main/Makefile.kmk	(revision 17929)
@@ -199,4 +199,6 @@
 	$(if $(VBOX_WITH_DBUS),VBOX_WITH_DBUS,) \
 	$(if $(VBOX_USB_WITH_SYSFS),VBOX_USB_WITH_SYSFS,)
+
+VBoxSVC_CXXFLAGS = $(filter-out -Wno-unused,$(TEMPLATE_VBOXMAINEXE_CXXFLAGS))
 
 ifdef VBOX_WITH_USB
Index: /trunk/src/VBox/Main/VirtualBoxImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 17928)
+++ /trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 17929)
@@ -717,4 +717,6 @@
 VirtualBox::COMGETTER(SharedFolders) (ComSafeArrayOut (ISharedFolder *, aSharedFolders))
 {
+    NOREF(aSharedFoldersSize);
+
     CheckComArgOutSafeArrayPointerValid(aSharedFolders);
 
Index: /trunk/src/VBox/Main/generic/NetIf-generic.cpp
===================================================================
--- /trunk/src/VBox/Main/generic/NetIf-generic.cpp	(revision 17928)
+++ /trunk/src/VBox/Main/generic/NetIf-generic.cpp	(revision 17929)
@@ -78,5 +78,5 @@
 }
 
-int NetIfEnableStaticIpConfig(VirtualBox *vBox, HostNetworkInterface * pIf, ULONG ip, ULONG mask)
+int NetIfEnableStaticIpConfig(VirtualBox * /* vBox */, HostNetworkInterface * pIf, ULONG ip, ULONG mask)
 {
     char szAddress[16]; /* 4*3 + 3*1 + 1 */
@@ -91,5 +91,5 @@
 }
 
-int NetIfEnableStaticIpConfigV6(VirtualBox *vBox, HostNetworkInterface * pIf, IN_BSTR aIPV6Address, ULONG aIPV6MaskPrefixLength)
+int NetIfEnableStaticIpConfigV6(VirtualBox * /* vBox */, HostNetworkInterface * pIf, IN_BSTR aIPV6Address, ULONG aIPV6MaskPrefixLength)
 {
     char szAddress[5*8 + 1 + 5 + 1];
@@ -99,25 +99,25 @@
 }
 
-int NetIfEnableDynamicIpConfig(VirtualBox *vBox, HostNetworkInterface * pIf)
+int NetIfEnableDynamicIpConfig(VirtualBox * /* vBox */, HostNetworkInterface * /* pIf */)
 {
     return VERR_NOT_IMPLEMENTED;
 }
 
-int NetIfCreateHostOnlyNetworkInterface (VirtualBox *pVbox, IHostNetworkInterface **aHostNetworkInterface, IProgress **aProgress)
+int NetIfCreateHostOnlyNetworkInterface (VirtualBox * /* pVbox */, IHostNetworkInterface ** /* aHostNetworkInterface */, IProgress ** /* aProgress */)
 {
     return VERR_NOT_IMPLEMENTED;
 }
 
-int NetIfRemoveHostOnlyNetworkInterface (VirtualBox *pVbox, IN_GUID aId, IHostNetworkInterface **aHostNetworkInterface, IProgress **aProgress)
+int NetIfRemoveHostOnlyNetworkInterface (VirtualBox * /* pVbox */, IN_GUID /* aId */, IHostNetworkInterface ** /* aHostNetworkInterface */, IProgress ** /* aProgress */)
 {
     return VERR_NOT_IMPLEMENTED;
 }
 
-int NetIfGetConfig(HostNetworkInterface * pIf, NETIFINFO *)
+int NetIfGetConfig(HostNetworkInterface * /* pIf */, NETIFINFO *)
 {
     return VERR_NOT_IMPLEMENTED;
 }
 
-int NetIfDhcpRediscover(VirtualBox *pVbox, HostNetworkInterface * pIf)
+int NetIfDhcpRediscover(VirtualBox * /* pVbox */, HostNetworkInterface * /* pIf */)
 {
     return VERR_NOT_IMPLEMENTED;
Index: /trunk/src/VBox/Main/linux/HostHardwareLinux.cpp
===================================================================
--- /trunk/src/VBox/Main/linux/HostHardwareLinux.cpp	(revision 17928)
+++ /trunk/src/VBox/Main/linux/HostHardwareLinux.cpp	(revision 17929)
@@ -90,12 +90,15 @@
                                      const char *pszKey, const char *pszValue,
                                      RTMemAutoPtr <DBusMessage, VBoxDBusMessageUnref> *pMessage);
+/*
 static int halFindDeviceStringMatchVector (DBusConnection *pConnection,
                                            const char *pszKey,
                                            const char *pszValue,
                                            std::vector<std::string> *pMatches);
+*/
 static int halGetPropertyStrings (DBusConnection *pConnection,
                                   const char *pszUdi, size_t cKeys,
                                   const char **papszKeys, char **papszValues,
                                   RTMemAutoPtr <DBusMessage, VBoxDBusMessageUnref> *pMessage);
+/*
 static int halGetPropertyStringsVector (DBusConnection *pConnection,
                                         const char *pszUdi, size_t cProps,
@@ -103,4 +106,5 @@
                                         std::vector<std::string> *pMatches,
                                         bool *pfMatches, bool *pfSuccess);
+*/
 static int getDriveInfoFromHal(DriveInfoList *pList, bool isDVD,
                                bool *pfSuccess);
@@ -632,5 +636,5 @@
     if (halSuccess)
     {
-        dbus_bus_add_match (dbusConnection.get(), 
+        dbus_bus_add_match (dbusConnection.get(),
                             "type='signal',"
                             "interface='org.freedesktop.Hal.Manager',"
@@ -680,5 +684,5 @@
     if (halSuccess)
     {
-        dbus_bus_add_match (dbusConnection.get(), 
+        dbus_bus_add_match (dbusConnection.get(),
                             "type='signal',"
                             "interface='org.freedesktop.Hal.Manager',"
@@ -708,5 +712,5 @@
     autoDBusError dbusError;
 
-    dbus_bus_remove_match (pConnection, 
+    dbus_bus_remove_match (pConnection,
                            "type='signal',"
                            "interface='org.freedesktop.Hal.Manager',"
@@ -730,5 +734,5 @@
     autoDBusError dbusError;
 
-    dbus_bus_remove_match (pConnection, 
+    dbus_bus_remove_match (pConnection,
                            "type='signal',"
                            "interface='org.freedesktop.Hal.Manager',"
@@ -925,5 +929,5 @@
 
     RTMemAutoPtr <DBusMessage, VBoxDBusMessageUnref> message, reply;
-    DBusMessageIter iterGet, iterProps, iterKey, iterValue;
+    DBusMessageIter iterGet, iterProps;
 
     /* Initialise the return array to NULLs */
@@ -1202,5 +1206,5 @@
             USBDeviceInfo info (pszDevice, pszSysfsPath);
             bool ifaceSuccess = true;  /* If we can't get the interfaces, just
-                                        * skip this one device. */            
+                                        * skip this one device. */
             rc = getUSBInterfacesFromHal (&info.mInterfaces, pszUdi, &ifaceSuccess);
             if (RT_SUCCESS(rc) && halSuccess && ifaceSuccess)
@@ -1287,5 +1291,5 @@
             USBDeviceInfo info (pszDevice, pszSysfsPath);
             bool ifaceSuccess = false;  /* If we can't get the interfaces, just
-                                         * skip this one device. */            
+                                         * skip this one device. */
             rc = getUSBInterfacesFromHal (&info.mInterfaces, pszSysfsPath,
                                           &ifaceSuccess);
@@ -1411,5 +1415,5 @@
  */
 /* static */
-DBusHandlerResult dbusFilterFunction (DBusConnection *pConnection,
+DBusHandlerResult dbusFilterFunction (DBusConnection * /* pConnection */,
                                       DBusMessage *pMessage, void *pvUser)
 {
Index: /trunk/src/VBox/Main/xpcom/server.cpp
===================================================================
--- /trunk/src/VBox/Main/xpcom/server.cpp	(revision 17928)
+++ /trunk/src/VBox/Main/xpcom/server.cpp	(revision 17929)
@@ -774,5 +774,5 @@
 };
 
-static void signal_handler (int sig)
+static void signal_handler (int /* sig */)
 {
     if (gEventQ && gKeepRunning)