Index: trunk/src/VBox/Main/include/DHCPServerImpl.h
===================================================================
--- trunk/src/VBox/Main/include/DHCPServerImpl.h	(revision 18023)
+++ trunk/src/VBox/Main/include/DHCPServerImpl.h	(revision 18023)
@@ -0,0 +1,102 @@
+/* $Id$ */
+
+/** @file
+ *
+ * VirtualBox COM class implementation
+ */
+
+/*
+ * Copyright (C) 2006-2009 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+#ifndef ____H_H_DHCPSERVERIMPL
+#define ____H_H_DHCPSERVERIMPL
+
+#include "VirtualBoxBase.h"
+#include "VirtualBoxImpl.h"
+
+#ifdef VBOX_WITH_HOSTNETIF_API
+/* class DHCPServer; */
+/* #include "netif.h" */
+struct NETIFINFO;
+#endif
+
+class ATL_NO_VTABLE DHCPServer :
+    public VirtualBoxBaseNEXT,
+    public VirtualBoxSupportErrorInfoImpl <DHCPServer, IDHCPServer>,
+    public VirtualBoxSupportTranslation <DHCPServer>,
+    public IDHCPServer
+{
+public:
+
+    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT (DHCPServer)
+
+    DECLARE_NOT_AGGREGATABLE (DHCPServer)
+
+    DECLARE_PROTECT_FINAL_CONSTRUCT()
+
+    BEGIN_COM_MAP (DHCPServer)
+        COM_INTERFACE_ENTRY (ISupportErrorInfo)
+        COM_INTERFACE_ENTRY (IDHCPServer)
+    END_COM_MAP()
+
+    NS_DECL_ISUPPORTS
+
+    DECLARE_EMPTY_CTOR_DTOR (DHCPServer)
+
+    HRESULT FinalConstruct();
+    void FinalRelease();
+
+    HRESULT init(VirtualBox *aVirtualBox, IN_BSTR aName);
+    HRESULT init(VirtualBox *aVirtualBox, const settings::Key &aNode);
+    HRESULT saveSettings (settings::Key &aParentNode);
+
+    void uninit();
+
+    // IDHCPServer properties
+    STDMETHOD(COMGETTER(NetworkName)) (BSTR *aName);
+    STDMETHOD(COMGETTER(Enabled)) (BOOL *aEnabled);
+    STDMETHOD(COMSETTER(Enabled)) (BOOL aEnabled);
+    STDMETHOD(COMGETTER(IPAddress)) (BSTR *aIPAddress);
+    STDMETHOD(COMGETTER(NetworkMask)) (BSTR *aNetworkMask);
+    STDMETHOD(COMGETTER(LowerIP)) (BSTR *aIPAddress);
+    STDMETHOD(COMGETTER(UpperIP)) (BSTR *aIPAddress);
+
+    STDMETHOD(SetConfiguration) (IN_BSTR aIPAddress, IN_BSTR aNetworkMask, IN_BSTR aFromIPAddress, IN_BSTR aToIPAddress);
+
+    // for VirtualBoxSupportErrorInfoImpl
+    static const wchar_t *getComponentName() { return L"DHCPServer"; }
+
+private:
+    /** weak VirtualBox parent */
+    const ComObjPtr <VirtualBox, ComWeakRef> mVirtualBox;
+
+    const Bstr mName;
+
+    struct Data
+    {
+        Data() : enabled(FALSE) {}
+
+        Bstr IPAddress;
+        Bstr networkMask;
+        Bstr lowerIP;
+        Bstr upperIP;
+        BOOL enabled;
+    } m;
+
+};
+
+#endif // ____H_H_DHCPSERVERIMPL
+/* vi: set tabstop=4 shiftwidth=4 expandtab: */
Index: trunk/src/VBox/Main/include/DhcpServerImpl.h
===================================================================
--- trunk/src/VBox/Main/include/DhcpServerImpl.h	(revision 18014)
+++ 	(revision )
@@ -1,102 +1,0 @@
-/* $Id$ */
-
-/** @file
- *
- * VirtualBox COM class implementation
- */
-
-/*
- * Copyright (C) 2006-2009 Sun Microsystems, Inc.
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
- */
-
-#ifndef ____H_H_DHCPSERVERIMPL
-#define ____H_H_DHCPSERVERIMPL
-
-#include "VirtualBoxBase.h"
-#include "VirtualBoxImpl.h"
-
-#ifdef VBOX_WITH_HOSTNETIF_API
-/* class DhcpServer; */
-/* #include "netif.h" */
-struct NETIFINFO;
-#endif
-
-class ATL_NO_VTABLE DhcpServer :
-    public VirtualBoxBaseNEXT,
-    public VirtualBoxSupportErrorInfoImpl <DhcpServer, IDhcpServer>,
-    public VirtualBoxSupportTranslation <DhcpServer>,
-    public IDhcpServer
-{
-public:
-
-    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT (DhcpServer)
-
-    DECLARE_NOT_AGGREGATABLE (DhcpServer)
-
-    DECLARE_PROTECT_FINAL_CONSTRUCT()
-
-    BEGIN_COM_MAP (DhcpServer)
-        COM_INTERFACE_ENTRY (ISupportErrorInfo)
-        COM_INTERFACE_ENTRY (IDhcpServer)
-    END_COM_MAP()
-
-    NS_DECL_ISUPPORTS
-
-    DECLARE_EMPTY_CTOR_DTOR (DhcpServer)
-
-    HRESULT FinalConstruct();
-    void FinalRelease();
-
-    HRESULT init(VirtualBox *aVirtualBox, IN_BSTR aName);
-    HRESULT init(VirtualBox *aVirtualBox, const settings::Key &aNode);
-    HRESULT saveSettings (settings::Key &aParentNode);
-
-    void uninit();
-
-    // IDhcpServer properties
-    STDMETHOD(COMGETTER(NetworkName)) (BSTR *aName);
-    STDMETHOD(COMGETTER(Enabled)) (BOOL *aEnabled);
-    STDMETHOD(COMSETTER(Enabled)) (BOOL aEnabled);
-    STDMETHOD(COMGETTER(IPAddress)) (BSTR *aIPAddress);
-    STDMETHOD(COMGETTER(NetworkMask)) (BSTR *aNetworkMask);
-    STDMETHOD(COMGETTER(LowerIP)) (BSTR *aIPAddress);
-    STDMETHOD(COMGETTER(UpperIP)) (BSTR *aIPAddress);
-
-    STDMETHOD(SetConfiguration) (IN_BSTR aIPAddress, IN_BSTR aNetworkMask, IN_BSTR aFromIPAddress, IN_BSTR aToIPAddress);
-
-    // for VirtualBoxSupportErrorInfoImpl
-    static const wchar_t *getComponentName() { return L"DhcpServer"; }
-
-private:
-    /** weak VirtualBox parent */
-    const ComObjPtr <VirtualBox, ComWeakRef> mVirtualBox;
-
-    const Bstr mName;
-
-    struct Data
-    {
-        Data() : enabled(FALSE) {}
-
-        Bstr IPAddress;
-        Bstr networkMask;
-        Bstr lowerIP;
-        Bstr upperIP;
-        BOOL enabled;
-    } m;
-
-};
-
-#endif // ____H_H_DHCPSERVERIMPL
-/* vi: set tabstop=4 shiftwidth=4 expandtab: */
Index: trunk/src/VBox/Main/include/VirtualBoxImpl.h
===================================================================
--- trunk/src/VBox/Main/include/VirtualBoxImpl.h	(revision 18014)
+++ trunk/src/VBox/Main/include/VirtualBoxImpl.h	(revision 18023)
@@ -54,5 +54,5 @@
 class Host;
 class SystemProperties;
-class DhcpServer;
+class DHCPServer;
 
 #ifdef RT_OS_WINDOWS
@@ -134,5 +134,5 @@
     STDMETHOD(COMGETTER(SharedFolders)) (ComSafeArrayOut (ISharedFolder *, aSharedFolders));
     STDMETHOD(COMGETTER(PerformanceCollector)) (IPerformanceCollector **aPerformanceCollector);
-    STDMETHOD(COMGETTER(DhcpServers)) (ComSafeArrayOut (IDhcpServer *, aDhcpServers));
+    STDMETHOD(COMGETTER(DHCPServers)) (ComSafeArrayOut (IDHCPServer *, aDHCPServers));
 
     /* IVirtualBox methods */
@@ -186,9 +186,9 @@
     STDMETHOD(SaveSettingsWithBackup) (BSTR *aBakFileName);
 
-//    STDMETHOD(CreateDhcpServerForInterface) (/*IHostNetworkInterface * aIinterface, */IDhcpServer ** aServer);
-    STDMETHOD(CreateDhcpServer) (IN_BSTR aName, IDhcpServer ** aServer);
-//    STDMETHOD(FindDhcpServerForInterface) (IHostNetworkInterface * aIinterface, IDhcpServer ** aServer);
-    STDMETHOD(FindDhcpServerByName) (IN_BSTR aName, IDhcpServer ** aServer);
-    STDMETHOD(RemoveDhcpServer) (IDhcpServer * aServer);
+//    STDMETHOD(CreateDHCPServerForInterface) (/*IHostNetworkInterface * aIinterface, */IDHCPServer ** aServer);
+    STDMETHOD(CreateDHCPServer) (IN_BSTR aName, IDHCPServer ** aServer);
+//    STDMETHOD(FindDHCPServerForInterface) (IHostNetworkInterface * aIinterface, IDHCPServer ** aServer);
+    STDMETHOD(FindDHCPServerByNetworkName) (IN_BSTR aName, IDHCPServer ** aServer);
+    STDMETHOD(RemoveDHCPServer) (IDHCPServer * aServer);
 
     /* public methods only for internal purposes */
@@ -373,5 +373,5 @@
     typedef std::list <ComObjPtr <FloppyImage> > FloppyImageList;
     typedef std::list <ComObjPtr <SharedFolder> > SharedFolderList;
-    typedef std::list <ComObjPtr <DhcpServer> > DhcpServerList;
+    typedef std::list <ComObjPtr <DHCPServer> > DHCPServerList;
 
     typedef std::map <Guid, ComObjPtr<HardDisk> > HardDiskMap;
@@ -396,7 +396,7 @@
     HRESULT registerMachine (Machine *aMachine);
 
-    HRESULT registerDhcpServer(DhcpServer *aDhcpServer,
+    HRESULT registerDHCPServer(DHCPServer *aDHCPServer,
                                          bool aSaveRegistry = true);
-    HRESULT unregisterDhcpServer(DhcpServer *aDhcpServer,
+    HRESULT unregisterDHCPServer(DHCPServer *aDHCPServer,
                                          bool aSaveRegistry = true);
 
@@ -447,5 +447,5 @@
         FloppyImageList mFloppyImages;
         SharedFolderList mSharedFolders;
-        DhcpServerList mDhcpServers;
+        DHCPServerList mDHCPServers;
 
         /// @todo NEWMEDIA do we really need this map? Used only in