Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp	(revision 18065)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageHelp.cpp	(revision 18069)
@@ -77,9 +77,9 @@
         RTPrintf("VBoxManage list [--long|-l] vms|runningvms|ostypes|hostdvds|hostfloppies|\n"
 #if (defined(RT_OS_WINDOWS) && defined(VBOX_WITH_NETFLT))
-                "                            bridgedifs|hostonlyifs|dhcpservers|hostinfo|hddbackends|hdds|dvds|floppies|\n"
+                "                            bridgedifs|hostonlyifs|dhcpservers|hostinfo|\n"
 #else
-                "                            bridgedifs|hostinfo|dhcpservers|hddbackends|hdds|dvds|floppies|\n"
-#endif
-
+                "                            bridgedifs|hostinfo|dhcpservers|\n"
+#endif
+                 "                            hddbackends|hdds|dvds|floppies|\n"
                  "                            usbhost|usbfilters|systemproperties\n"
                  "\n");
@@ -112,16 +112,4 @@
                  "                            [-basefolder <path> | -settingsfile <path>]\n"
                  "                            [-uuid <uuid>]\n"
-                 "\n");
-    }
-
-    if (u64Cmd & USAGE_IMPORTAPPLIANCE)
-    {
-        RTPrintf("VBoxManage import           <ovf>\n"
-                 "\n"); // @todo
-    }
-
-    if (u64Cmd & USAGE_EXPORTAPPLIANCE)
-    {
-        RTPrintf("VBoxManage export           <machines> [--output|-o] <ovf>\n"
                  "\n");
     }
@@ -245,4 +233,16 @@
     }
 
+    if (u64Cmd & USAGE_IMPORTAPPLIANCE)
+    {
+        RTPrintf("VBoxManage import           <ovf> [--dry-run|-n] [more options]\n"
+                 "    (run with -n to have options displayed for a particular OVF)\n\n");
+    }
+
+    if (u64Cmd & USAGE_EXPORTAPPLIANCE)
+    {
+        RTPrintf("VBoxManage export           <machines> [--output|-o] <ovf>\n"
+                 "\n");
+    }
+
     if (u64Cmd & USAGE_STARTVM)
     {
@@ -473,5 +473,6 @@
     if (u64Cmd & USAGE_METRICS)
     {
-        RTPrintf("VBoxManage metrics          list [*|host|<vmname> [<metric_list>]] (comma-separated)\n\n"
+        RTPrintf("VBoxManage metrics          list [*|host|<vmname> [<metric_list>]] \n"
+                 "                                                 (comma-separated)\n\n"
                  "VBoxManage metrics          setup\n"
                  "                            [-period <seconds>]\n"
@@ -492,7 +493,7 @@
     {
         RTPrintf("VBoxManage hostonlyif       ipconfig <name> \n"
-                 "                                     [-dhcp| \n"
-                 "                                      -ip<ipv4> [-netmask<ipv4> (default is 255.255.255.0)]| \n"
-                 "                                      -ipv6<ipv6> [-netmasklengthv6<length> (default is 64)]]\n"
+                 "                            [-dhcp| \n"
+                 "                            -ip<ipv4> [-netmask<ipv4> (deflt: 255.255.255.0)]| \n"
+                 "                            -ipv6<ipv6> [-netmasklengthv6<length> (deflt: 64)]]\n"
 # if defined(RT_OS_WINDOWS)
                  "                            create |\n"
@@ -506,5 +507,6 @@
     if (u64Cmd & USAGE_DHCPSERVER)
     {
-        RTPrintf("VBoxManage dhcpserver       [add | modify] [-netname <network_name> | -ifname <hostonly_if_name>]\n"
+        RTPrintf("VBoxManage dhcpserver       add|modify -netname <network_name> |\n"
+                 "                                        -ifname <hostonly_if_name>\n"
                  "                                [-ip <ip_address>\n"
                  "                                 -netmask <network_mask>\n"
@@ -512,5 +514,6 @@
                  "                                 -upperip <upper_ip>]\n"
                  "                                [-enable | -disable]\n"
-                 "                            remove [-netname <network_name> | -ifname <hostonly_if_name>]\n"
+                 "VBoxManage dhcpserver       remove -netname <network_name> |\n"
+                 "                                   -ifname <hostonly_if_name>\n"
                  "\n");
     }